<?php
require('../common.php');
if ( $argc < 2 )   die();

/*
  00-03 CHR size
  04-07 ??? offset
  08-0b ??? offset
  0c-0f CLUT offset
  10-13 *repeat* Sprite Data

  Sprite Data
  00 Width
  01 Height
  02 ???
  03 ???
 */

function chrhead( $s, &$sum, &$sz, &$max_w, &$max_h )
{
	if ( !isset( $sum[$s] ) )
		$sum[$s] = 0;
	$sum[$s]++;

	/*
	  24w : 0xbc4 -0xe64  (0x2a0) sprite = 0xc  x 0x38 (8A)
	  32w : 0x114 -0x494  (0x380) sprite = 0x10 x 0x38 (8E)
	  40w : 0x2794-0x2bf4 (0x460) sprite = 0x14 x 0x38 (92)

	  HERO00A.CHR
	    32-5   40-2   32-4   40-1   32-1
	    40-3   32-1   40-8   32-1   40-5
	    32-1   40-2   32-1   40-4   32-2
	    40-22  32-1   40-1
	    = 32w*17(0x11) + 40w*48(0x30) = 65(0x41)

	  868e = 32x56 = 0x700/2 = 0x380
	  8692 = 40x56 = 0x8c0/2 = 0x460

	  858e = 32x48 = 0x600/2 = 0x300
	  8592 = 40x48 = 0x780/2 = 0x3c0
	 */

	$t1 = ( $s & 0x7f );
		$w = $t1 + 2;
	$t1 = ( $s >> 8 ) & 0xf;
		$h = ($t1 + 1) * 8;

	//printf("%x = %d * %d\n", $s, $w*2, $h);
	if ( $w > $max_w )   $max_w = $w;
	if ( $h > $max_h )   $max_h = $h;
	$sz += ( $w*$h );
}

for ( $i=1; $i < $argc; $i++ )
{
	$fp  = fopen( $argv[$i], "rb" );
	printf("--- %s ---\n", $argv[$i]);

	$off = 0x10;
	$spr_s = frint2b( $fp, $off );
	$spr_sum = array();
	$spr_sz = 0;
	$max_w = 0;
	$max_h = 0;
	while ( $spr_s > 0 )
	{
		chrhead( $spr_s, $spr_sum, $spr_sz, $max_w, $max_h );
		$off += 4;
		$spr_s = frint2b( $fp, $off );
	}

	$spr_n = 0;
	foreach( $spr_sum as $k=>$v )
	{
		printf("SUM 0x%x : %d (0x%x)\n", $k, $v, $v);
		$spr_n += $v;
	}
	printf("TOTAL : %d (0x%x)\n", $spr_n, $spr_n);
	$st = 0x10 + ($spr_n*4);
	printf("EXPECTED START : 0x%x\n", $st );
	printf("EXPECTED END   : 0x%x\n", $st + $spr_sz);
	printf("MAX W : %d*2 = %d\n", $max_w, $max_w*2 );
	printf("MAX H : %d\n", $max_h );
	echo "\n";

	fclose($fp);
}
